#include <hxcpp.h>

#ifndef INCLUDED_snow_types_AssetType
#include <snow/types/AssetType.h>
#endif
namespace snow{
namespace types{

::snow::types::AssetType AssetType_obj::audio;

::snow::types::AssetType AssetType_obj::bytes;

::snow::types::AssetType AssetType_obj::image;

::snow::types::AssetType AssetType_obj::text;

HX_DEFINE_CREATE_ENUM(AssetType_obj)

int AssetType_obj::__FindIndex(::String inName)
{
	if (inName==HX_CSTRING("audio")) return 3;
	if (inName==HX_CSTRING("bytes")) return 0;
	if (inName==HX_CSTRING("image")) return 2;
	if (inName==HX_CSTRING("text")) return 1;
	return super::__FindIndex(inName);
}

int AssetType_obj::__FindArgCount(::String inName)
{
	if (inName==HX_CSTRING("audio")) return 0;
	if (inName==HX_CSTRING("bytes")) return 0;
	if (inName==HX_CSTRING("image")) return 0;
	if (inName==HX_CSTRING("text")) return 0;
	return super::__FindArgCount(inName);
}

Dynamic AssetType_obj::__Field(const ::String &inName,bool inCallProp)
{
	if (inName==HX_CSTRING("audio")) return audio;
	if (inName==HX_CSTRING("bytes")) return bytes;
	if (inName==HX_CSTRING("image")) return image;
	if (inName==HX_CSTRING("text")) return text;
	return super::__Field(inName,inCallProp);
}

static ::String sStaticFields[] = {
	HX_CSTRING("bytes"),
	HX_CSTRING("text"),
	HX_CSTRING("image"),
	HX_CSTRING("audio"),
	::String(null()) };

static void sMarkStatics(HX_MARK_PARAMS) {
	HX_MARK_MEMBER_NAME(AssetType_obj::audio,"audio");
	HX_MARK_MEMBER_NAME(AssetType_obj::bytes,"bytes");
	HX_MARK_MEMBER_NAME(AssetType_obj::image,"image");
	HX_MARK_MEMBER_NAME(AssetType_obj::text,"text");
};

#ifdef HXCPP_VISIT_ALLOCS
static void sVisitStatic(HX_VISIT_PARAMS) {
	HX_VISIT_MEMBER_NAME(AssetType_obj::__mClass,"__mClass");
	HX_VISIT_MEMBER_NAME(AssetType_obj::audio,"audio");
	HX_VISIT_MEMBER_NAME(AssetType_obj::bytes,"bytes");
	HX_VISIT_MEMBER_NAME(AssetType_obj::image,"image");
	HX_VISIT_MEMBER_NAME(AssetType_obj::text,"text");
};
#endif

static ::String sMemberFields[] = { ::String(null()) };
Class AssetType_obj::__mClass;

Dynamic __Create_AssetType_obj() { return new AssetType_obj; }

void AssetType_obj::__register()
{

hx::Static(__mClass) = hx::RegisterClass(HX_CSTRING("snow.types.AssetType"), hx::TCanCast< AssetType_obj >,sStaticFields,sMemberFields,
	&__Create_AssetType_obj, &__Create,
	&super::__SGetClass(), &CreateAssetType_obj, sMarkStatics
#ifdef HXCPP_VISIT_ALLOCS
    , sVisitStatic
#endif
#ifdef HXCPP_SCRIPTABLE
    , 0
#endif
);
}

void AssetType_obj::__boot()
{
hx::Static(audio) = hx::CreateEnum< AssetType_obj >(HX_CSTRING("audio"),3);
hx::Static(bytes) = hx::CreateEnum< AssetType_obj >(HX_CSTRING("bytes"),0);
hx::Static(image) = hx::CreateEnum< AssetType_obj >(HX_CSTRING("image"),2);
hx::Static(text) = hx::CreateEnum< AssetType_obj >(HX_CSTRING("text"),1);
}


} // end namespace snow
} // end namespace types
